package net.sarcommand.fft.demo;

/**
 * @author A. O. Ergueven, Torsten Heup
 */
public abstract class TransformThread extends Thread {
    final FFTDemo demo;
    final String _opName;

    public TransformThread(final FFTDemo invoker, final String opName){
        setPriority(Thread.MIN_PRIORITY);
        setName("Fourier transform thread.");

        _opName = opName;
        demo = invoker;
    }
    public void run(){
        demo._glassPane.setVisible(true);
        demo._progressDlg.setVisible(true);
        demo._statusTF.setText("Applying "+_opName+"...");
        final long beginTime = System.nanoTime();

        transform();

        final long delta = (System.nanoTime() - beginTime) / 1000000;
        demo._statusTF.setText(_opName+" completed in "+delta +" miliseconds.");
        demo._progressDlg.setVisible(false);
        demo._glassPane.setVisible(false);
        demo.validate();
    }

    public abstract void transform();
}
